+++
title = "The Value of Open Source Platforms"
date = 2006-04-03T22:34:45
in_search_index = true
[taxonomies]
tags = [
	"Open-Source",
	"Software-Development",
]
+++
People ask me at times why I like Open Source so much. It's true that OSS can sometimes take a little more work up front. Sometimes, however, OSS is the only way to solve a problem quickly and with the least amount of trouble. Take my current project for example. I have a client with legacy code on an IIS server written in ASP/VBScript. Now I have nothing particular against ASP. In many ways I cut my teeth on ASP. However IIS CGI scripting has a nasty little bug which is rare but just happened to affect me. Certain Database connections will cause the IIS and the CGI application to get out of sync. The result of which is that the webserver sends absolutely nothing to the browser. No error page. No data. Nothing. Now how are you supposed to fix that? The client can't just ditch his legacy code. He can't upgrade IIS without a significant cost. And there is no Patch. There are some workarounds but none of them work predictably 100% of the time. So what is an enterprising Programmer to do? Introducing Apache as a backend server. Apache just happens to be completely unaffected by this little problem. So my solution? Set up Apache2 and Modperl to serve out the data to the IIS server. Use an MSXML object in the ASP code to retrieve the page and display it right along side the legacy code to the browser. Now the legacy code can exist side by side with the new code and In addition we can kill two birds with one stone by taking one more step toward the goal of migrating the application to an Apache/Perl/Mysql orPgSQL infrastructure. What was the advantage of OSS in this situation? It provided a solution that I could implement immediately with no licensing changes, no cost, and no problems. I didn't have to talk to a sales rep. I didn't have to talk to tech support. I just went ahead and implemented it. Now try doing that with a closed source solution. OSS has readily available solutions with little or no overhead. I guess that's why so many hacker types like the environment to work in. We like to solve problems. We don't like waiting on other people to solve them for us. 
